#ifndef UPKG_H_
#define UPKG_H_

#define UPKG_FLAG_ALLOW_DOWNLOAD  0x0001
#define UPKG_FLAG_CLIENT_OPTIONAL 0x0002
#define UPKG_FLAG_SERVER_ONLY     0x0004
#define UPKG_FLAG_BROKEN_LINKS    0x0008
#define UPKG_FLAG_INSECURE        0x0010
#define UPKG_FLAG_REQUIRED        0x8000

#define UPKG_OBJ_FLAG_TRANSACTIONAL   0x00000001
#define UPKG_OBJ_FLAG_UNREACHABLE     0x00000002
#define UPKG_OBJ_FLAG_PUBLIC          0x00000004
#define UPKG_OBJ_FLAG_TAG_IMPORT      0x00000008
#define UPKG_OBJ_FLAG_TAG_EXPORT      0x00000010
#define UPKG_OBJ_FLAG_SOURCE_MODIFIED 0x00000020
#define UPKG_OBJ_FLAG_TAG_GARBAGE     0x00000040
#define UPKG_OBJ_FLAG_NEED_LOAD       0x00000200
#define UPKG_OBJ_FLAG_HIGHLIGHT_NAME  0x00000400

#define UPKG_HDR_MAGIC 0x9e2a83c1
#define UPKG_HDR_SIZE  36

struct upkg {
	unsigned version, license;
	unsigned long flags;

	unsigned long name_count, export_count, import_count;

	struct upkg_private *priv;
};

struct upkg *upkg_fopen(const char *path);
int upkg_close(struct upkg *pkg);
const char *upkg_get_name(struct upkg *pkg, unsigned long idx);

#endif
